local hpRegenAmount = 0.001
local flyRegenAmount = 0.0025

local player_entity = EntityGetWithTag("player_unit")[1]
if (player_entity == nil) then return end

local damagemodels = EntityGetComponent(player_entity, "DamageModelComponent")
if (damagemodels == nil) then return end

for i, damagemodel in ipairs(damagemodels) do
	local hp = tonumber(ComponentGetValue(damagemodel, "hp"))
	local max_hp = tonumber(ComponentGetValue(damagemodel, "max_hp"))
	if (hp ~= nil and max_hp ~= nil) then
		if (hp > 0) then
			if (hp < max_hp) then
				hp = hp + hpRegenAmount
				if (hp > max_hp) then
					hp = max_hp
				end
				ComponentSetValue(damagemodel, "hp", hp)
			end
		end
	end
end

local characterdatas = EntityGetComponent(player_entity, "CharacterDataComponent")
if(characterdatas == nil) then return end

for i, characterdata in ipairs(characterdatas) do
	local mFlyingTimeLeft = tonumber(ComponentGetValue(characterdata, "mFlyingTimeLeft"))
	if (mFlyingTimeLeft > 0 and mFlyingTimeLeft < 3) then
		ComponentSetValue(characterdata, "mFlyingTimeLeft", mFlyingTimeLeft + flyRegenAmount)
	end
end
